/*
  lily-proto.hh -- declare class names.

  source file of the GNU LilyPond music typesetter

  (c) 1997 Han-Wen Nienhuys <hanwen@stack.nl>
*/

#ifndef LILY_PROTO_HH
#define LILY_PROTO_HH
#include "proto.hh"

struct My_lily_lexer;
struct Absolute_dynamic_req;
struct Accidental;
struct Atom;
struct Bar;
struct Bar_register;
struct Bar_req;
struct Barcheck_req;
struct Beam;
struct Beam_req;
struct Blank_req;
struct Box;
struct Bracket_req;
struct Cadenza_req;
struct Chord;
struct Clef_change_req;
struct Clef_item;
struct Clef_register;
struct Col_hpositions;
struct Colinfo;
struct Collision;
struct Collision_register;
struct Command_req;
struct Complex_music;
struct Complex_walker;
struct Cresc_req;
struct Crescendo ;
struct Decresc_req;
struct Directional_spanner;
struct Durational_req;
struct Dynamic;
struct Dynamic_req;
struct Element_group;
struct Feature;
struct Group_change_req;
struct Group_feature_req;
struct Idealspacing;
struct Identifier;
struct Input;
struct Input_file;
struct Input_music;
struct Input_register;
struct Input_score;
struct Input_staff;
struct Item;
struct Key;
struct Key_change_req;
struct Key_item;
struct Key_register;
struct Keyword;
struct Keyword_table;
struct Lily_stream;
struct Line_of_score;
struct Line_of_staff;
struct Linestaff;
struct Local_key;
struct Local_key_item;
struct Local_key_register;
struct Lookup;
struct Lyric_item;
struct Lyric_req;
struct Measure_grouping_req;
struct Melodic_req;
struct Meter;
struct Meter_change_req;
struct Meter_register;
struct Midi_def;
struct Midi_duration;
struct Midi_header;
struct Midi_item;
struct Midi_output;
struct Midi_pitch;
struct Midi_score;
struct Midi_staff;
struct Midi_stream;
struct Midi_track;
struct Midi_walker;
struct Mixed_qp;
struct Molecule;
struct Music_general_chord;
struct Music_voice;
struct Musical_req;
struct My_lily_parser;
struct Note_column;
struct Note_column_register;
struct Note_req;
struct Note_head;
struct Note_head_register;
struct Notename_table;
struct Offset;
struct Output;
struct PCol;
struct PScore;
struct Paper_def;
struct Partial_measure_req;
struct Plet;
struct Plet_req;
struct Pulk_voice;
struct Pulk_voices;
struct Rational;
struct Register_group_register;
struct Request;
struct Request_column;
struct Request_register;
struct Rest;
struct Rest_collision;
struct Rest_collision_register;
struct Rest_column;
struct Rest_req;
struct Rhythmic_grouping;
struct Rhythmic_grouping_req;
struct Rhythmic_req;
struct Score;
struct Score_column;
struct Score_elem;
struct Score_elem_info;
struct Score_walker;
struct Script;
struct Script_column;
struct Script_def;
struct Script_register;
struct Script_req;
struct Simple_music;
struct Skip_req;
struct Slur;
struct Slur_register;
struct Slur_req;
struct Spacing_req ;
struct Span_dynamic_req;
struct Span_req;
struct Spanner;
struct Staff;
struct Staff_column;
struct Staff_side;
struct Staff_symbol;
struct Staff_walker;
struct Stem;
struct Stem_beam_register;
struct Stem_req;
struct String;
struct Subtle_req;
struct Symbol;
struct Symtable;
struct Symtables;
struct Super_elem;
struct Terminate_voice_req;
struct Tex_stream;
struct Text_def;
struct Text_gob;
struct Text_item ;
struct Text_register;
struct Text_req;
struct Tie;
struct Tie_register;
struct Tie_req;
struct Time_description;
struct Timing_req;
struct Vertical_brace;
struct Vertical_spanner;
struct Voice;
struct Voice_element;
struct Voice_group_registers;
struct Voice_list;
struct Voice_registers;
struct Voicegroup;
struct Walker_registers;
typedef Rational Moment;
#endif // LILY_PROTO_HH
